keys = {"leg/fr/", "leg/rr/", "leg/rl/", "leg/fl/"}

legs = {"leg/fr/alfa", "leg/fl/alfa", "leg/rr/alfa", "leg/rl/alfa"}

alfas = {"leg/fr/alfa", "leg/fl/alfa", "leg/rr/alfa", "leg/rl/alfa"}
betas = {"leg/fr/beta", "leg/fl/beta", "leg/rr/beta", "leg/rl/beta"}
gamas = {"leg/fr/gama", "leg/fl/gama", "leg/rr/gama", "leg/rl/gama"}

dirs = {{1,-1,0}, {1,1,0}, {-1,1,0}, {-1,-1,0}}

goal_angles = {0.785, 3.1415, 3.1415}

joint_goto{joints=alfas, pos=goal_angles[1], time=1.}
joint_goto{joints=betas, pos=goal_angles[2], time=1.}
joint_goto{joints=gamas, pos=goal_angles[3], time=1.}
block_yield{joints=alfas}
block_yield{joints=betas}
block_yield{joints=gamas}

for i=1,3 do
	for i,s in pairs({0.05,-0.05}) do
		body_move{dir={0,0,s}, rot={{0,0,1},0}, time=0.2}
		block_yield{joints=betas}
		block_yield{joints=gamas}
	end	
end

body_move{dir={0,0.1,0}, rot={{0,0,1},0}, time=0.2}
block_yield{joints=betas}
block_yield{joints=gamas}
for i=1,3 do	
	body_move{dir={0,-0.1,0}, rot={{0,0,1},0}, time=0.2}
	block_yield{joints=betas}
	block_yield{joints=gamas}

	body_move{dir={0,0.1,0}, rot={{0,0,1},0}, time=0.2}
	block_yield{joints=betas}
	block_yield{joints=gamas}
end
body_move{dir={0,-0.1,0}, rot={{0,0,1},0}, time=0.2}
block_yield{joints=betas}
block_yield{joints=gamas}

joint_goto{joints=alfas, pos=goal_angles[1], time=1.}
joint_goto{joints=betas, pos=goal_angles[2], time=1.}
joint_goto{joints=gamas, pos=goal_angles[3], time=1.}
block_yield{joints=alfas}
block_yield{joints=betas}
block_yield{joints=gamas}

for i,val in pairs({0}) do
	body_move{dir={0,0,0}, rot={{0,1,0},val}, time=0.2, steps=64}
	block_yield{joints=betas}
	block_yield{joints=gamas}
end
