#include "node/state_machines/action_pack.h"
#include "node/state_machines/simple.h"

#include <variant>

#pragma once

namespace schpin
{

struct plan_item
{
        std::string                                                       name;
        std::variant< action_pack_state_machine, statelog_state_machine > machine;
};

using plan = std::vector< plan_item >;

}  // namespace schpin
